SystemOrganization addCategory: #'PathObjects-Widgets'!

UiListViewport subclass: #SPOSingleLineListViewport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOSingleLineListViewport methodsFor: 'add/remove - appending' stamp: 'ls 5/31/2013 10:57:15.183'!
appendMorph: aMorph inRow: aRowInfo forIndex: aModelIndex
	
	super appendMorph: aMorph inRow: aRowInfo forIndex: aModelIndex.
	self morphAdded: aMorph.! !

!SPOSingleLineListViewport methodsFor: 'rows/columns - to cell' stamp: 'ls 5/25/2013 18:57:03.628'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| localPt | 
	localPt := aPoint - self topLeft.
	cellToBounds first withIndexDo: [:cellSpec :colIndex |
		cellSpec ifNotNil: [cellSpec first x + cellSpec second x >= localPt x ifTrue: [^ colIndex@1]]].
	
	^ nil! !

!SPOSingleLineListViewport methodsFor: 'drawing' stamp: 'ls 5/22/2013 18:01:14.919'!
drawGroupSeparator: aMorph on: aCanvas
		
	aCanvas fullDrawMorph: aMorph.! !

!SPOSingleLineListViewport methodsFor: 'signals' stamp: 'ls 5/31/2013 10:52:46.108'!
morphAdded: aMorph
	
	self emit.! !

!SPOSingleLineListViewport methodsFor: 'layouting' stamp: 'ls 5/22/2013 19:00:13.04'!
updateSingleColumnHorizontalLayout
	
	| cell hOffset previousItemWidth |
	"Compute virtual row and column count."
	vRowCount := 1.
	vColumnCount := self rowCountVisible.
	
	"Prepare cache and running variables."
	cellToBounds := {Array new: vColumnCount}. "one row only"
	cell := 0@1.
	hOffset := 0.
	previousItemWidth := nil.

	self rowsDo: [:rowInfo | rowInfo visible ifTrue: [ | item |
		cell := cell + (1 @ 0).
		item := rowInfo items first.
		previousItemWidth ifNotNil: [:w | hOffset := hOffset + w].
		previousItemWidth := item width.		
		item topLeft: hOffset @ 0.
		
		"Fill bounds cache."
		cellToBounds first at: cell x put: {hOffset@0. item extent x @ maxItemExtent y. rowInfo}]].
			
	"Update dynamically-sized dimension."
	self width: self submorphBounds width.! !

LayoutPolicy subclass: #SPOSearchEditLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOSearchEditLayout methodsFor: 'layout' stamp: 'ls 8/6/2013 15:30:42.74'!
layout: searchEdit in: newBounds
	
	searchEdit submorphsDo: [:s | s fullBounds].
	
	searchEdit input 
		topLeft: (searchEdit topLeft + (4@0));
		width: (searchEdit width - 20).
	searchEdit clearBtn topRight: (searchEdit topRight - (4@ -5)).! !

UiLabel subclass: #SPOFlatButton
	instanceVariableNames: 'originalForm dimmedForm enabled'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOFlatButton methodsFor: 'signals' stamp: 'ls 5/29/2013 16:53:05.594'!
clicked
	
	self enabled ifFalse: [^ self].
	self emitAlways.! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:07:56.366'!
dimmedForm
	
	^ dimmedForm! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:07:49.228'!
dimmedForm: aForm
	
	dimmedForm := aForm.! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:55:20.355'!
enabled
	
	^ enabled ifNil: [enabled := true]! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:52:06.335'!
enabled: aBool
	
	enabled := aBool.! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:23:50.176'!
form: aForm
	
	self 
		originalForm: aForm;
		dimmedForm: aForm dimmed.
	
	super form: self dimmedForm.! !

!SPOFlatButton methodsFor: 'initialization' stamp: 'ls 7/31/2013 11:44:47.277'!
initialize
	
	super initialize.
	text contents: ''.
	self 
		form: UiSilkIcons sport8ballIcon;
		extent: 16@16;
		initializeSignals.! !

!SPOFlatButton methodsFor: 'initialization' stamp: 'ls 7/31/2013 11:44:29.833'!
initializeSignals
	
	self eventHandler: UiEventHandler new.
	self eventHandler setProperty: #handlesMouseOver toValue: [true].
	
	self
		connect: self eventHandler signal: #mouseEntered: toSelector: #onMouseEntered;
		connect: self eventHandler signal: #mouseLeft: toSelector: #onMouseLeft;
		connect: self eventHandler signal: #mouseLeftDragging: toSelector: #onMouseLeft;
		connect: self eventHandler signal: #mouseClicked: toSelector: #clicked.! !

!SPOFlatButton methodsFor: 'signals-callbacks' stamp: 'ls 7/31/2013 11:43:55.222'!
onMouseEntered
	
	self enabled ifFalse: [^ self].
	super form: self originalForm.  ! !

!SPOFlatButton methodsFor: 'signals-callbacks' stamp: 'ls 7/31/2013 11:43:59.941'!
onMouseLeft
	
	super form: self dimmedForm.! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:14:13.312'!
originalForm
	
	^ originalForm! !

!SPOFlatButton methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:14:25.368'!
originalForm: aForm
	
	originalForm := aForm.! !

Morph subclass: #SPOSearchEdit
	instanceVariableNames: 'input clearBtn resultList resultListDecorator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOSearchEdit methodsFor: 'adding' stamp: 'ls 6/3/2013 22:35:47.411'!
addClassResult: aClassName
	
	resultList model addChild: (
		UiPropertyItemNode new
			at: #key put: aClassName;
			at: #index put: #classIndex;
			at: #icon put: UiFugueIcons documentAttributeCIcon;
			yourself).! !

!SPOSearchEdit methodsFor: 'adding' stamp: 'ls 6/3/2013 22:36:17.474'!
addInstanceResult: anInstanceName
	
	resultList model addChild: (
		UiPropertyItemNode new
			at: #key put: anInstanceName;
			at: #index put: #instanceIndex;
			at: #icon put: UiFugueIcons documentAttributeIIcon;
			yourself).! !

!SPOSearchEdit methodsFor: 'adding' stamp: 'ls 6/3/2013 22:36:33.947'!
addMessageResult: aMessageName
	
	resultList model addChild: (
		UiPropertyItemNode new
			at: #key put: aMessageName;
			at: #index put: #messageIndex;
			at: #icon put: UiFugueIcons documentAttributeMIcon;
			yourself).! !

!SPOSearchEdit methodsFor: 'accessing' stamp: 'ls 6/4/2013 11:14:33.356'!
clearBtn
	
	^ clearBtn ifNil: [clearBtn := SPOFlatButton new
		form: (UiSilkIcons crossIcon scaledToSize: 10@10);
		visible: false;
		yourself]! !

!SPOSearchEdit methodsFor: 'drawing' stamp: 'ls 5/29/2013 15:49:44.992'!
drawOn: aCanvas
	
	UiPainter default new
		drawSearchEdit: self on: aCanvas.! !

!SPOSearchEdit methodsFor: 'testing' stamp: 'ls 6/4/2013 11:07:18.485'!
hasSearchTerm
	
	^ self searchTerm isNil not! !

!SPOSearchEdit methodsFor: 'search' stamp: 'ls 6/3/2013 22:11:29.107'!
hideResults

	resultListDecorator owner ifNil: [^ self].
	resultListDecorator delete.
	
	self redrawLater.! !

!SPOSearchEdit methodsFor: 'initialization' stamp: 'ls 8/6/2013 15:27:51.273'!
initialize
	
	super initialize.
	
	self
		initializeResultList;
		initializeResultListDecorator.
	
	self
		layoutPolicy: SPOSearchEditLayout new;  
		color: Color white;
		extent: 180@20;
		addMorph: self input;
		addMorph: self clearBtn;
		initializeSignals.! !

!SPOSearchEdit methodsFor: 'initialization' stamp: 'ls 6/4/2013 11:12:11.564'!
initializeResultList
	
	resultList := UiListView new
		extent: 340@150;
		selectionBehavior: #selectRows;
		removeVerticalHeader;
		removeHorizontalHeader;
		selectionMode: UiViewSingleSelection;  
		model: UiPropertyItemNode new;
		listSpec: (UiItemViewColumnSpec newFrom: {#text -> #key. #icon -> #icon}).
	
	self
		connect: resultList signal: #clicked: toSelector: #selectResultNode:;
		connect: resultList signal: #returnPressed: toSelector: #selectResultNode:;
		connect: resultList eventHandler signal: #focusLostInSubmorph: toSelector: #onFocusLost.! !

!SPOSearchEdit methodsFor: 'initialization' stamp: 'ls 6/3/2013 22:11:16.199'!
initializeResultListDecorator

	resultListDecorator := SPOSearchResultDecorator new.
	resultListDecorator addMorph: resultList.
	resultListDecorator fullBounds.! !

!SPOSearchEdit methodsFor: 'initialization' stamp: 'ls 6/4/2013 11:16:48.031'!
initializeSignals
	
	self 
		connect: self input eventHandler signal: #focusReceived toSelector: #onFocusReceived;
		connect: self input eventHandler signal: #focusLost toSelector: #onFocusLost;
		connect: self input signal: #textEdited: toSelector: #startSearch;
		connect: self input signal: #returnPressed: toSelector: #selectResultText:.
	
	self input eventHandler 
		on: Character arrowDown send: #passKeyboardFocusToResultList to: self;
		on: Character arrowUp send: #passKeyboardFocusToResultList to: self.
		
	self
		connect: self clearBtn signal: #clicked toSelector: #onSearchCleared.! !

!SPOSearchEdit methodsFor: 'accessing' stamp: 'ls 5/29/2013 16:49:56.758'!
input
	
	^ input ifNil: [
		input := UiLineEdit new.
		input
			helpText: 'Type to search';
			outerBorderWidth: 0;
			margins: (0@2 corner: 0@0).
		input]! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 6/3/2013 22:21:28.721'!
onFocusLost
	
	self updateFocusColor: false.
	(self input hasKeyboard or: [resultList hasAnyKeyboard])
		ifFalse: [self hideResults].! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 6/4/2013 10:52:10.505'!
onFocusReceived
	
	self updateFocusColor: true.
	self startSearch.! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 6/4/2013 12:22:28.768'!
onSearchCleared
	
	self input 
		theText: '';
		releaseKeyboard.
	
	self
		searchResultChanged: nil;
		hideResults.
		
	self clearBtn visible: false.! !

!SPOSearchEdit methodsFor: 'accessing' stamp: 'ls 5/29/2013 14:47:32.153'!
outerBorderWidth
	
	^ 1! !

!SPOSearchEdit methodsFor: 'accessing' stamp: 'ls 5/29/2013 15:49:10.086'!
outerBounds
	
	^ self bounds outsetBy: self outerBorderWidth! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 6/4/2013 10:40:04.507'!
passKeyboardFocusToResultList
	
	resultList grabKeyboard.
	resultList selectNextRow.! !

!SPOSearchEdit methodsFor: 'accessing' stamp: 'ls 6/3/2013 21:26:35.627'!
searchIndex
	
	^ self owner owner owner interactionModel searchIndex! !

!SPOSearchEdit methodsFor: 'signals' stamp: 'ls 6/4/2013 12:12:48.598'!
searchResultChanged: newResultSet
	
	self emit.! !

!SPOSearchEdit methodsFor: 'search' stamp: 'ls 9/15/2013 16:00:14.885'!
searchResultFor: key in: index
	
	index = #unknown 
		ifFalse: [^ (self searchIndex perform: index) at: key ifAbsent: [Set new]]
		ifTrue: [^ self searchIndex anythingMatching: key]! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 7/30/2013 15:13:48.714'!
selectResultNode: aNode
	
	aNode ifNil: [^ self].
	self hideResults.
	self input theText: aNode key.
	self searchResultChanged: (self searchResultFor: aNode key in: aNode index).
	self clearBtn visible: true.! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 6/4/2013 12:15:55.535'!
selectResultText: aText
	
	aText size = 0 ifTrue: [^ self].
	
	self hideResults.
	self searchResultChanged: (self searchResultFor: aText string in: #unknown).
	self clearBtn visible: true.! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 7/30/2013 15:08:13.395'!
selectResultText: aText index: aSymbol
	
	self input theText: aText.
	self searchResultChanged: (self searchResultFor: aText in: aSymbol).
	self clearBtn visible: true.! !

!SPOSearchEdit methodsFor: 'search' stamp: 'ls 6/4/2013 10:50:57.049'!
showResults

	resultListDecorator comeToFront.
	resultListDecorator topRight: self bottomRight + (2@1).
	
	resultListDecorator owner ifNil: [resultListDecorator openInWorld].
	
	self redrawLater.! !

!SPOSearchEdit methodsFor: 'signals-callbacks' stamp: 'ls 6/4/2013 10:51:04.612'!
startSearch
	
	resultList model
		removeAllGroups;
		addDefaultGroup.
	
	(self searchIndex classesMatching: self input theText)
		do: [:each | self addClassResult: each].
	
	(self searchIndex instancesMatching: self input theText)
		do: [:each | self addInstanceResult: each].
		
	(self searchIndex messagesMatching: self input theText)
		do: [:each | self addMessageResult: each].
		
	self showResults.! !

!SPOSearchEdit methodsFor: 'drawing' stamp: 'ls 5/29/2013 15:59:44.998'!
updateFocusColor: hasFocus
	
	hasFocus
		ifTrue: [self color: (Color r: 0.0 g: 0.0 b: 0.5) muchLighter paler]
		ifFalse: [self color: Color white]! !

Morph subclass: #SPOSearchResultDecorator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOSearchResultDecorator methodsFor: 'drawing' stamp: 'ls 6/3/2013 22:10:20.012'!
drawOn: aCanvas
	
	super drawOn: aCanvas.
	
	aCanvas
		frameRectangle: (self bounds insetBy: (2@2 corner: 0 @ 0))  
		width: 1
		color: (Color gray: 0.5).

	aCanvas
		frameRectangle: (self bounds insetBy: (0@0 corner: 1@1))
		width: 1
		color: (Color gray: 0.75).
	
	aCanvas
		fillRectangle: (self bounds insetBy: (1@1 corner: 2@2))
		color: Color white.! !

!SPOSearchResultDecorator methodsFor: 'initialization' stamp: 'ls 6/3/2013 22:10:10.621'!
initialize
	
	super initialize.
	self
		changeTableLayout;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		layoutInset: 4;
		sticky: true.! !

Morph subclass: #SPOToolbar
	instanceVariableNames: 'searchEdit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOToolbar methodsFor: 'signals' stamp: 'ls 7/5/2013 13:00:10.872'!
actionTriggered: aSymbol
	
	self emitAlways.! !

!SPOToolbar methodsFor: 'adding' stamp: 'ls 9/15/2013 16:01:42.253'!
addFilterIcons
	
	| group button1 button2 |
	group := self buildGroup.
	
	button1 := self 
		buildTextButton: 'Message Filter'
		with: UiFugueIcons funnelPencilIcon 
		and: nil.
	button2 := self 
		buildButtonWith: UiSilkIcons arrowRefreshSmallIcon 
		and: 'Refresh layout'.
		
	group
		addMorphBack: button1;
		addMorphBack: button2.
	self addMorphBack: group.
	
	self
		connect: button1 signal: #clicked: toSelector: #actionTriggered: pattern: #(=editFilter);
		connect: button2 signal: #clicked: toSelector: #actionTriggered: pattern: #(=refreshLayout).! !

!SPOToolbar methodsFor: 'adding' stamp: 'ls 8/6/2013 18:43:27.828'!
addLegendToggle
	
	| button |
	button := self 
		buildButtonWith: UiFugueIcons colorIcon
		and: 'toggle legend'.
	button
		checkable: true;
		checked: false.
	
	self 
		connect: button signal: #clicked: toSelector: #actionTriggered: pattern: #(=toggleLegend);
		addMorphBack: button.! !

!SPOToolbar methodsFor: 'adding' stamp: 'ls 8/6/2013 18:51:25.314'!
addMiniMapToggle
	
	| button |
	button := self 
		buildButtonWith: UiFugueIcons mapMediumIcon
		and: 'Toggle minimap'.
	button
		checkable: true;
		checked: true.
	
	self 
		connect: button signal: #clicked: toSelector: #actionTriggered: pattern: #(=toggleMiniMap);
		addMorphBack: button.! !

!SPOToolbar methodsFor: 'adding' stamp: 'ls 12/3/2013 17:02:46.762'!
addOverlayButtons
	
	| group button1 button2 |
	group := self buildGroup.
	
	button1 := self 
		buildTextButton: 'Information Layers'
		with: UiFugueIcons layersStackArrangeBackIcon
		and: nil.
	
	button2 := self 
		buildButtonWith: UiFugueIcons colorIcon
		and: 'toggle legend'.
	button2
		checkable: true;
		checked: false.
	
	group 
		addMorphBack: button1;
		addMorphBack: button2.
	
	self 
		connect: button1 signal: #clicked: toSelector: #actionTriggered: pattern: #(=manageOverlays);
		connect: button2 signal: #clicked: toSelector: #actionTriggered: pattern: #(=toggleLegend);
		addMorphBack: group.! !

!SPOToolbar methodsFor: 'adding' stamp: 'ls 6/4/2013 12:20:59.43'!
addSearchBar
	
	| group |
	group := self buildGroup.
	group
		addMorphBack: self searchEdit;
		addMorphBack: (self buildSpacer: 8).
	self 
		addMorphBack: UiSpacer new;
		addMorphBack: group.! !

!SPOToolbar methodsFor: 'adding' stamp: 'ls 6/3/2013 15:29:49.17'!
addSeparator
	
	self addMorphBack: self buildSeparator.! !

!SPOToolbar methodsFor: 'building' stamp: 'ls 6/3/2013 15:20:27.683'!
buildButtonWith: icon and: text
	
	^ UiToolButton new
		text: text;
		icon: icon;
		layoutInset: (2@2 corner: 2@2);
		balloonText: text;
		buttonStyle: #iconOnly;
		autoRaise: true! !

!SPOToolbar methodsFor: 'building' stamp: 'ls 6/1/2013 14:58:33.574'!
buildGroup
	
	^ UiContainer new 
		changeTableLayout; 
		listDirection: #leftToRight; 
		hResizing: #shrinkWrap; 
		vResizing: #shrinkWrap; 
		layoutInset: 0; 
		cellInset: 0! !

!SPOToolbar methodsFor: 'building' stamp: 'ls 6/1/2013 14:58:46.112'!
buildSeparator
	
	^ UiContainer new
		vResizing: #spaceFill;
		hResizing: #rigid;
		fillStyle: (self gradient: Color gray);
		layoutInset: 0;
		cellInset: 0;
		width: 1! !

!SPOToolbar methodsFor: 'building' stamp: 'ls 6/1/2013 15:04:34.885'!
buildSpacer: aWidth
	
	^ UiContainer new
		vResizing: #rigid;
		hResizing: #rigid;
		layoutInset: 0;
		cellInset: 0;
		height: 1;
		width: aWidth! !

!SPOToolbar methodsFor: 'building' stamp: 'ls 8/5/2013 18:58:01.806'!
buildTextButton: text with: icon and: helpText
	
	^ UiToolButton new
		text: text;
		icon: icon;
		layoutInset: (2@2 corner: 2@2);
		balloonText: helpText;
		buttonStyle: #textBesideIcon;
		autoRaise: true! !

!SPOToolbar methodsFor: 'drawing' stamp: 'ls 6/1/2013 13:51:51.367'!
drawBackground
	
	| color fill |
	color := Color r: 0.844 g: 0.863 b: 0.91.
	fill := GradientFillStyle ramp: {0.0 -> color muchLighter. 1.0 -> color twiceDarker}.
	fill 
		origin: self topLeft;
		direction: 0 @ self height.
	self fillStyle: fill.! !

!SPOToolbar methodsFor: 'building' stamp: 'ls 8/19/2013 22:57:51.916'!
gradient: aColor
	
	^ (GradientFillStyle 
		ramp: {
			0.1 -> (aColor alpha: 0.0).
			0.5 -> aColor.
			0.9 -> (aColor alpha: 0.0).
		})
		origin: self topLeft;
		direction: 0 @ self height! !

!SPOToolbar methodsFor: 'initialization' stamp: 'ls 8/6/2013 18:49:21.393'!
initialize

	super initialize.
	
	self
		changeTableLayout;
		vResizing: #rigid;
		hResizing: #shrinkWrap;
		listDirection: #leftToRight;
		borderWidth: 0;
		color: Color transparent;
		drawBackground;
		height: 30;
		layoutInset: (0@1 corner: 0@0);
		cellInset: 5.
		
	self
		addMorphBack: (self buildSpacer: 0);
		addOverlayButtons;
		addSeparator;
		addFilterIcons;
		addSeparator;
		addMiniMapToggle;
		addSeparator;
		addSearchBar.! !

!SPOToolbar methodsFor: 'accessing' stamp: 'ls 6/4/2013 12:20:45.032'!
searchEdit
	
	^ searchEdit ifNil: [searchEdit := SPOSearchEdit new]! !

!UiGlossyPainter methodsFor: '*PathObjects-Widgets' stamp: 'ls 5/29/2013 14:09:23.272'!
drawSearchEditEnabledOn: aCanvas

	| fillStyleLower fillStyleUpper c |
	c := (self morph input hasKeyboard not and: [self morph input hasUnacceptedChanges])
		ifTrue: [self colorChanged]
		ifFalse: [self color].
	
	self morph outerBorderWidth > 0 ifTrue: [
		fillStyleLower := self fillStyleLower colorRamp:  {
			0.0 -> (c mixed: 0.81 with: self colorDarken).
			1.0 -> (c mixed: 0.85 with: self colorDarken)}.
		fillStyleUpper := self fillStyleUpper colorRamp: {
			0.0 -> (c mixed: 0.72 with: self colorDarken).
			1.0 -> (c mixed: 0.76 with: self colorDarken)}.

		aCanvas
			fillRectangle: (self upperBounds outsetBy: (1@0 corner: 1@0))
			fillStyle: fillStyleUpper.
		
		aCanvas
			fillRectangle: (self lowerBounds outsetBy: (1@0 corner: 1@0))
			fillStyle: fillStyleLower.
		
		aCanvas
			line: self outerBounds topLeft + (1@0)
			to: self outerBounds topRight - (2@0)
			width: 1
			color: fillStyleUpper colorRamp first value.

		aCanvas
			line: self outerBounds bottomLeft + (1@ -1)
			to: self outerBounds bottomRight - (2@ 1)
			width: 1
			color: fillStyleLower colorRamp last value.
	].

	"Fill background."
	aCanvas
		fillRoundRect: self bounds
		radius: 3
		fillStyle: (SolidFillStyle color: c).
! !

!UiPainter methodsFor: '*PathObjects-Widgets' stamp: 'ls 5/29/2013 14:33:32.853'!
drawSearchEdit: aSearchEdit on: aCanvas
	
	self morph: aSearchEdit.
	aSearchEdit enabled
		ifTrue: [self drawSearchEditEnabledOn: aCanvas]
		ifFalse: [self drawSearchEditDisabledOn: aCanvas].! !

!UiPainter methodsFor: '*PathObjects-Widgets' stamp: 'ls 5/29/2013 14:05:17.302'!
drawSearchEditDisabledOn: aCanvas
	
	! !

!UiPainter methodsFor: '*PathObjects-Widgets' stamp: 'ls 5/29/2013 14:05:10.829'!
drawSearchEditEnabledOn: aCanvas
	
	! !

UiScrollArea subclass: #SPOScrollArea
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOScrollArea class methodsFor: 'accessing' stamp: 'ls 5/25/2013 18:48:49.75'!
widgetCategory
	
	^ 'PathObjects'! !

!SPOScrollArea methodsFor: 'scrolling' stamp: 'ls 5/22/2013 11:33:28.437'!
centerAround: aPoint
	
	self setOffsetInsideBounds: aPoint - (self transformMorph extent / 2).! !

!SPOScrollArea methodsFor: 'scrolling-animated' stamp: 'ls 5/22/2013 12:05:25.545'!
centerAround: aPoint duration: milliseconds
	
	self 
		setOffsetInsideBounds: aPoint - (self transformMorph extent / 2)
		duration: milliseconds.! !

!SPOScrollArea methodsFor: 'initialization' stamp: 'ls 5/22/2013 11:19:23.309'!
initialize
	
	super initialize.
	self initializeSignals.! !

!SPOScrollArea methodsFor: 'initialization' stamp: 'ls 5/22/2013 11:21:21.703'!
initializeSignals
	
	self transformMorph
		on: #startDrag send: #startedDragging to: self;
		on: #mouseMove send: #transformerMoved: to: self.! !

!SPOScrollArea methodsFor: 'scrolling' stamp: 'ls 5/22/2013 11:31:39.339'!
scrollBy: delta
	"Move the contents in the direction delta."

	| newYoffset newXoffset |
	newYoffset := self transformMorph offset y - delta y max: 0.
	newXoffset := self transformMorph offset x - delta x max: -3.
	
	self transformMorph offset: newXoffset@newYoffset.! !

!SPOScrollArea methodsFor: 'scrolling-animated' stamp: 'ls 5/22/2013 12:05:02.892'!
scrollBy: delta duration: milliseconds
	"Move the contents in the direction delta."

	| newYoffset newXoffset newOffset anim |
	newYoffset := self transformMorph offset y - delta y max: 0.
	newXoffset := self transformMorph offset x - delta x max: -3.
	newOffset := newXoffset@newYoffset.
	
	newOffset = self transformMorph offset ifTrue: [^ self].
	
	self transformMorph drawCacheActive
		ifTrue: [self transformMorph updateDrawCache].
	
	(self valueOfProperty: #scrollAnimation ifAbsent: [])
		ifNotNil: [:an | an unregister].
	
	anim := (AnimPropertyAnimation
		on: self transformMorph
		property: #offset
		start: self transformMorph offset
		end: newOffset  
		duration: milliseconds).
	anim easingCurve conversionBlock: [:x | (-1 * (x-1 raisedTo: 6)) + 1].
	anim
		register;
		finishBlock: nil;
		start: #deleteWhenFinished.
	
	self setProperty: #scrollAnimation toValue: anim.! !

!SPOScrollArea methodsFor: 'scrolling' stamp: 'ls 5/22/2013 11:23:40.904'!
scrollInsideBoundsBy: offset
	"Scroll by anOffset, but make sure, that the viewport does not leave the allowed bounds."
	
	| newCenter centerRectangle |
	newCenter := self transformMorph center + offset.
	centerRectangle := self transformMorph submorphBounds insetBy: self transformMorph extent / 2.
	(centerRectangle containsPoint: newCenter)
		ifFalse: [newCenter := centerRectangle pointNearestTo: newCenter].
	self scrollBy: self transformMorph center - newCenter.! !

!SPOScrollArea methodsFor: 'scrolling-animated' stamp: 'ls 5/22/2013 12:06:06.527'!
scrollInsideBoundsBy: offset duration: milliseconds
	"Scroll by anOffset, but make sure, that the viewport does not leave the allowed bounds."
	
	| newCenter centerRectangle |
	newCenter := self transformMorph center + offset.
	centerRectangle := self transformMorph submorphBounds insetBy: self transformMorph extent / 2.
	(centerRectangle containsPoint: newCenter)
		ifFalse: [newCenter := centerRectangle pointNearestTo: newCenter].
	self 
		scrollBy: self transformMorph center - newCenter
		duration: milliseconds.! !

!SPOScrollArea methodsFor: 'scrolling' stamp: 'ls 5/22/2013 12:01:21.2'!
setOffsetInsideBounds: anOffset
	
	self scrollInsideBoundsBy: anOffset - self transformMorph offset.! !

!SPOScrollArea methodsFor: 'scrolling-animated' stamp: 'ls 5/22/2013 12:05:48.628'!
setOffsetInsideBounds: anOffset duration: milliseconds
	
	self 
		scrollInsideBoundsBy: anOffset - self transformMorph offset
		duration: milliseconds.! !

!SPOScrollArea methodsFor: 'signals-callbacks' stamp: 'ls 5/22/2013 11:22:09.259'!
startedDragging
	
	"Ignored event, needs to be registered to get the transformerMoved: events."! !

!SPOScrollArea methodsFor: 'signals-callbacks' stamp: 'ls 5/22/2013 11:22:38.46'!
transformerMoved: anEvent
	
	self scrollInsideBoundsBy: anEvent startPoint - anEvent position.! !

SystemWindow subclass: #SPOSystemWindow
	instanceVariableNames: 'child'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOSystemWindow methodsFor: 'menu' stamp: 'ls 8/7/2013 13:06:34.246'!
buildWindowMenu
	
	| aMenu |
	aMenu := super buildWindowMenu.
	^ self child buildWindowMenuOn: aMenu! !

!SPOSystemWindow methodsFor: 'accessing' stamp: 'ls 8/7/2013 13:04:12.591'!
child
	
	^ child! !

!SPOSystemWindow methodsFor: 'accessing' stamp: 'ls 8/7/2013 13:04:12.605'!
child: anObject
	
	child := anObject.! !

!SPOSystemWindow methodsFor: 'user interface' stamp: 'ls 7/9/2013 17:04:50.445'!
defaultBackgroundColor
	
	^ Color r: 71 g: 157 b: 230 range: 255! !

!SPOSystemWindow methodsFor: 'access' stamp: 'ls 7/9/2013 17:05:19.392'!
model
	
	^ self! !

UiTextEdit subclass: #SPOReadOnlyTextEdit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOReadOnlyTextEdit class methodsFor: 'as yet unclassified' stamp: 'or 6/24/2013 14:49:43.206'!
widgetClassName

	^ 'Readonly Text Edit'! !

!SPOReadOnlyTextEdit methodsFor: 'testing' stamp: 'ls 8/24/2013 15:43:50.074'!
hasKeyboard
	
	^ false! !

!SPOReadOnlyTextEdit methodsFor: 'initialization' stamp: 'ls 8/24/2013 15:41:55.159'!
initialize
	"using self>>readOnly would destroy all keyboard shortcuts
	like copy & paste, browse, etc"
	
	super initialize.
	self
		verticalScrollBarPolicy: #asNeeded;
		outerBorderWidth: 0;
		color: Color transparent;
		initializeSignals.
	
	self textMorph margins: (0@0corner: 10@0).! !

!SPOReadOnlyTextEdit methodsFor: 'initialization' stamp: 'ls 8/24/2013 15:41:07.487'!
initializeSignals
	
	self connect: self signal: #textEdited: toSelector: #revertChanges.! !

Object subclass: #SPOModalColorPicker
	instanceVariableNames: 'semaphore properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOModalColorPicker methodsFor: 'public api' stamp: 'ls 8/19/2013 22:52:28.356'!
letUserPickFor: anObject
	
	self semaphore: Semaphore new.
	
	[ColorPickerMorph new
		initializeModal: true;
		sourceHand: anObject activeHand;
		target: self;
		selector: #onColorPicked:;
		originalColor: self originalColor;		
		putUpFor: anObject
		near: self origin] fork.
	self semaphore wait.
	
	^ self pickedColor! !

!SPOModalColorPicker methodsFor: 'signals-callbacks' stamp: 'ls 8/19/2013 20:13:35.316'!
onColorPicked: aColor
	
	self pickedColor: aColor.
	self semaphore signal.! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 22:52:09.904'!
origin
	
	^ self properties
		at: #origin
		ifAbsent: [ActiveHand position]! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 22:49:59.13'!
originalColor
	
	^ self properties
		at: #originalColor
		ifAbsent: [Color red]! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 22:48:39.136'!
pickedColor
	
	^ self properties
		at: #pickedColor
		ifAbsent: [nil]! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 22:49:05.985'!
pickedColor: aColor
	
	self properties
		at: #pickedColor
		put: aColor.! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 22:48:14.037'!
properties
	
	^ properties ifNil: [properties := Dictionary new]! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 20:11:12.95'!
semaphore
	
	^ semaphore! !

!SPOModalColorPicker methodsFor: 'accessing' stamp: 'ls 8/19/2013 20:11:12.964'!
semaphore: anObject
	
	semaphore := anObject.! !

UiListView subclass: #SPOSingleLineListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOSingleLineListView class methodsFor: 'accessing' stamp: 'ls 5/25/2013 18:46:40.177'!
widgetCategory
	
	^ 'PathObjects'! !

!SPOSingleLineListView class methodsFor: 'accessing' stamp: 'ls 5/25/2013 18:48:27.599'!
widgetClassName
	
	^ 'Single Line List View'! !

!SPOSingleLineListView class methodsFor: 'properties' stamp: 'ls 5/25/2013 18:48:31.92'!
widgetProperties
	
	^ super widgetProperties, {{'List View'. #yourself} -> {
		#hAlignment -> #(left center right).
		#vAlignment -> #(top center bottom)}}! !

!SPOSingleLineListView methodsFor: 'initialization' stamp: 'ls 7/31/2013 11:39:09.086'!
initialize
	
	super initialize.
	self listOrientation: #horizontal.! !

!SPOSingleLineListView methodsFor: 'accessing - private' stamp: 'ls 5/22/2013 14:32:38.531'!
viewportClass

	^ SPOSingleLineListViewport! !

RectangleMorph subclass: #SPOColorLegendMorph
	instanceVariableNames: 'colors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PathObjects-Widgets'!

!SPOColorLegendMorph methodsFor: 'accessing' stamp: 'ls 8/6/2013 16:39:50.139'!
colors
	
	^ colors ifNil: [colors := OrderedCollection new]! !

!SPOColorLegendMorph methodsFor: 'accessing' stamp: 'ls 8/6/2013 16:37:58.321'!
colors: anObject
	
	colors := anObject.! !

!SPOColorLegendMorph methodsFor: 'utilities' stamp: 'ls 8/19/2013 22:44:54.251'!
convertToRelativePosition: aPoint
	
	| local |
	local := (self bounds topLeft - aPoint) * -1.
	^ (local x / self width) asFloat @ (local y / self height) asFloat! !

!SPOColorLegendMorph methodsFor: 'initialization' stamp: 'ls 8/6/2013 16:35:19.763'!
defaultBorderColor
	
	^ Color gray: 0.5! !

!SPOColorLegendMorph methodsFor: 'initialization' stamp: 'ls 8/6/2013 16:35:30.323'!
defaultBorderWidth
	
	^ 1! !

!SPOColorLegendMorph methodsFor: 'drawing' stamp: 'ls 8/6/2013 16:36:21.811'!
drawBordersOn: aCanvas
	
	aCanvas 
		frameRectangle: self bounds 
		width: self defaultBorderWidth 
		color: self defaultBorderColor.! !

!SPOColorLegendMorph methodsFor: 'drawing' stamp: 'ls 8/19/2013 22:44:23.732'!
drawColorsOn: aCanvas
	
	| last insetRect fillStyle |
	last := 0.0.
	self colors do: [:each |
		insetRect := self bounds
			insetOriginBy: ((self bounds width * last) asInteger@0)
			cornerBy: ((self bounds width - (self bounds width * each key)) asInteger@0).
		last := each key.
		fillStyle := GradientFillStyle colors: each value.
		fillStyle origin: insetRect topLeft.
		fillStyle direction: insetRect width@0.
		aCanvas fillRectangle: insetRect fillStyle: fillStyle].! !

!SPOColorLegendMorph methodsFor: 'drawing' stamp: 'ls 8/6/2013 16:36:01.702'!
drawOn: aCanvas
	
	self 
		drawColorsOn: aCanvas;
		drawBordersOn: aCanvas.! !

!SPOColorLegendMorph methodsFor: 'events-processing' stamp: 'ls 8/6/2013 17:28:05.624'!
handleMouseMove: anEvent
	
	anEvent wasHandled: true.
	self mouseMove: anEvent.! !

!SPOColorLegendMorph methodsFor: 'event handling' stamp: 'ls 8/6/2013 17:27:33.262'!
handlesMouseOver: evt
	
	^ true! !

!SPOColorLegendMorph methodsFor: 'initialization' stamp: 'ls 8/6/2013 17:38:38.831'!
initialize
	
	super initialize.
	self eventHandler: UiEventHandler new.
	self eventHandler setProperty: #source toValue: self.! !
